# aliexpress-price-tracker

Price tracker for aliexpress.

A file containing aliexpress login token cookies has to be provided in /app/cookies.json (obtained with cookie-quick-manager https://github.com/ysard/cookie-quick-manager/) for accurate prices (no "welcome discount").

## how to use (with podman)
### build
```
podman build --tag alipricetrack:1.0.0 -f ./Dockerfile
podman build --tag alipricetrack_cron:1.0.0 -f ./CronDockerfile
```

### run
```
podman pod create --name aliexpress -p 8080:8080

podman run -d --pod=aliexpress -e POSTGRES_DB="aliexpress" -e POSTGRES_USER="postgres" -e POSTGRES_PASSWORD="postgres" -v /home/data/podman/aliexpress/db:/var/lib/postgresql/data:Z --name ali-db docker.io/postgres

podman run -d --pod=aliexpress -e POSTGRES_DB="aliexpress" -e POSTGRES_USER="postgres" -e POSTGRES_PASSWORD="postgres" -v /home/data/podman/aliexpress/cookies.json:/app/cookies.json:Z --name ali-app alipricetrack:1.0.0

podman run -d --pod=aliexpress -e WAIT_TIME="1d" --name ali-cron alipricetrack_cron:1.0.0
```

WAIT_TIME is the time to wait between each database refresh, it can be in:

+ s : seconds
+ m : minutes
+ h : hours
+ d : days  

If not specified, default wait time is 1 day. </br></br>
For reverse proxy configuration see `example-nginx.conf`
